moSetGetInputOutputOther = {};

function moSetGetInputOutputOther:getOther(self, objectTable, category, xmlModString)	
	local inputFillTypes={};
	local outputFillTypes={};
	local ls17 = true;	
	local container = 1;
	local ratio = 0;
	local setProduktivity = false;
	local productivity = 0;
	local productivityColor = moGuiMiniPdaSlots.warningColor0;
	local outputFull = false;
	local inputEmpty = false;
	local capacity = 0;
	local fillLevel = 0;
	--print("sprung ....".. tostring(category).. " - ".. tostring(xmlModString))
	if objectTable ~= nil and category == "stocks" then		
		--print("sprung 1....")
		--print(tostring(MultiOverlayV2:tableToString(objectTable.objectData)));
		if objectTable.storage1 ~= nil and objectTable.objectData ~= nil then			
			--print("sprung 2....")
			local info={};			
			for k,v in pairs(objectTable.storage) do			
				info = {};
				info.container = container;				
				info.fillTypeName = "";
				info.lengthFillTypes = 1;
				info.capacity = v.capacity;
				--local pricePerLiter, fillTypeNameString = moSetGetInputOutputOther:getFillTypeStringName(self, k, info.fillTypeName, nil);
				info.fillTypeName = objectTable.objectData[k].uiNameId;
				info.pricePerLiter = 0;
				info.extraText = tostring(objectTable.objectData[k].uiImageId);
				info.setColor = moGuiMiniPdaSlots.warningColor1;									
				info.fillLevel = #v.storedItems;
				inputFillTypes[container] = {};
				table.insert(inputFillTypes[container], info);
				table.remove(info);
				container = container+1;
			end;
		end;
		if objectTable.storage ~= nil and objectTable.objectData ~= nil then
			function setCostPerDay()
				local info = {};			
				info.fillTypeName = tostring(moLanguageXml:getTxt("costperday", nil, "Cost(Day)"));		
				info.lengthFillTypes = 1;		
				info.pricePerLiter = 0;
				if not inputEmpty then info.pricePerLiter = tonumber(Utils.getNoNil(objectTable.incomePerHour, 0));end;		
				--print("price per liter....".. tostring(info.pricePerLiter))
				info.fillLevel = 0;
				info.capacity = -2;
				if info.pricePerLiter == 0 then 
					info.extraText = tostring(moLanguageXml:getTxt("costperdayno", nil, "No"));
					info.setColor = moGuiMiniPdaSlots.warningColor0;
				else
					info.extraText = tostring(moLanguageXml:getTxt("costperdayon", nil, "Yes"));
					info.setColor = moGuiMiniPdaSlots.warningColor2
				end;
				outputFillTypes[container] = {};
				table.insert(outputFillTypes[container], info);
				container = container+1;
			end;		
			
				--together
				for k, v in pairs(objectTable.storage) do
					info = {};
					info.fillLevel = Utils.getNoNil(#v.storedItems, 0);
					fillLevel = fillLevel+info.fillLevel;
					info.capacity = v.capacity;
					capacity = capacity+info.capacity;
					info.pricePerLiter = moSetGetInputOutputOther:getFruitPrice(self, v);
					info.fillTypeName = objectTable.objectData[k].uiNameId;
					info.lengthFillTypes = 1;
					inputFillTypes[container] = {};
					table.insert(inputFillTypes[container], info);
					container = container+1;
				end;
			
			container = 1;
			local info = {};
			info.fillTypeName = tostring(moLanguageXml:getTxt("capacity", nil, "Capacity"));		
			info.lengthFillTypes = 1;
			info.pricePerLiter = 0;			
			info.fillLevel = fillLevel;
			info.capacity = capacity;			
			info.productivity = string.format("%1.0f", "".. tonumber(fillLevel)/tonumber(capacity)*100);
			info.productivityColor = moSetGetInputOutputOther:getProzentColor(info.productivity); --moGuiExtras.colors['green'];
			outputFillTypes[container] = {};
			table.insert(outputFillTypes[container], info);
			container = container+1;
			setCostPerDay();
		end;
	elseif objectTable ~= nil and category == "animals" then		
		if objectTable.Trough ~= nil then --and string.find(xmlModString, "chickensfarm") then			
			local info={};			
			
			
			info.fillTypeName = tostring(moLanguageXml:getTxt("chicken", nil, "Chicken")).. " ".. tostring(moLanguageXml:getTxt("amount", nil, "Amount"));		
			info.lengthFillTypes = 1;
			info.pricePerLiter = 0;		
			info.fillLevel = Utils.getNoNil(objectTable.totalChickens, 0);
			info.capacity = -1;
			if objectTable.breedingState == 2 then
				info.productivity = string.format("%1.0f", Utils.getNoNil(objectTable.prodTwoCheck, 0));
			else
				info.productivity = string.format("%1.0f", Utils.getNoNil(objectTable.prodOneCheck, 0)); --Utils.getNoNil(objectTable.productivity*100, 0); --string.format("%0.0f", Utils.getNoNil(0, 0));
			end;
			info.productivityColor = getProductivityColor(self, info.productivity); --moGuiExtras.colors['green'];
			outputFillTypes[container] = {};
			table.insert(outputFillTypes[container], info);
			container = container+1;
			
			
			info = {};
			info.fillLevel = Utils.getNoNil(g_currentMission:getNumPickupObjects(FillUtil.FILLTYPE_EGG), 0);
			info.capacity = -1;
			info.pricePerLiter = getEggPrice(self, FillUtil.FILLTYPE_EGG);
			info.fillTypeName = tostring(moLanguageXml:getTxt("a_pickup", nil, "Pickup"));		
			info.lengthFillTypes = 1;
			outputFillTypes[container] = {};
			table.insert(outputFillTypes[container], info);
			container = container+1;
			
			info = {};
			info.fillLevel = Utils.getNoNil(objectTable.eggsToSpawn, 0);
			info.capacity = -1;
			info.fillTypeName = tostring(moLanguageXml:getTxt("a_egg1", nil, "Eggs in the barn"));		
			info.lengthFillTypes = 1;
			info.setColor = moGuiMiniPdaSlots.warningColor0;			
			info.pricePerLiter = 0;
			outputFillTypes[container] = {};
			table.insert(outputFillTypes[container], info);		
			container = 1;
			
			info = {};			
			for k,v in pairs(objectTable.Trough) do			
				local accepts = true;
				if objectTable.Trough[k].typeName == "Bedding" and (objectTable.breedingState == 1 or objectTable.breedingState == 3) then
					accepts = false;
				end;
				if accepts then
					local factor = objectTable.updateDelay / 1440
					info = {};
					info.container = container;				
					info.fillTypeName = "";
					info.lengthFillTypes = 0;
					info.capacity = 0; --v.usagePerDay * objectTable.totalChickens * factor;
					--local usedCapacity = math.min(info.capacity, v.fillLevel)
					--info.capacity = usedCapacity;
					info.pricePerLiter = 0;
					info.fillTypeContainerName = tostring(moLanguageXml:getTxt(tostring(objectTable.Trough[k].typeName), nil, tostring(objectTable.Trough[k].typeName)));
					info.fillLevel = v.fillLevel;
					
					acceptedFillTypes = v.acceptedFillTypes;				
					for fillType,isAccepted in pairs(acceptedFillTypes) do			
						if(isAccepted)then				
							local pricePerLiter, fillTypeNameString = moSetGetInputOutputOther:getFillTypeStringName(self, fillType, info.fillTypeName, nil);
							if info.fillTypeName ~= fillTypeNameString then info.lengthFillTypes = info.lengthFillTypes+1;info.fillTypeName = fillTypeNameString;end;
						end;
					end;
					if objectTable.Trough[k].typeName == "Water" then
						if info.lengthFillTypes == 1 then
							info.fillTypeContainerName = nil;
							info.fillTypeName = tostring(moLanguageXml:getTxt("a_watertrough", nil, "WaterTrog"));
						end;
					elseif objectTable.Trough[k].typeName == "Bedding" then
						if info.lengthFillTypes == 1 then
							info.fillTypeContainerName = nil;
							info.fillTypeName = tostring(moLanguageXml:getTxt("a_straw", nil, "Straw"));
						end;
					elseif objectTable.Trough[k].typeName == "BaseFood" then
						info.fillTypeContainerName = tostring(moLanguageXml:getTxt("a_foodtrough"), nil, tostring(objectTable.Trough[k].typeName));
					end;
					inputFillTypes[container] = {};
					table.insert(inputFillTypes[container], info);
					table.remove(info);
					container = container+1;
				end;
			end;
		end;
	end;
	--fs17_enhancedchickens_placeable.enhancedchickens
	if not ls17 and objectTable ~= nil and xmlModString == nil then		
		local name = "";
		if objectTable.name ~= nil then name = string.lower(string.gsub(objectTable.name, " ", ""));end;
		local otherType = "";
		if objectTable.otherType ~= nil then otherType = string.lower(objectTable.otherType);end;
		if string.find(name, "mischstation") or name == "ruebenschneider" or otherType == "mischstation" then --Mischstation,Rübenschneider			
			setProduktivity = true;
			local info={};
			info.capacity = objectTable.LvLIndicator.capacity;	
			info.fillLevel = objectTable.MixLvl;
			ratio = Utils.getNoNil(info.fillLevel/info.capacity*100, 0);
			if tonumber(ratio) >= 100 then outputFull = true;end;
			--if tonumber(productivity) >= tonumber(ratio) then
			--	productivity = tonumber(ratio);	
			--end;
			info.container = container;
			info.fillTypeName = "";
			info.lengthFillTypes = 1;					
			outputFillTypes[container] = {};
			local pricePerLiter, fillTypeNameString = moSetGetInputOutputOther:getFillTypeStringName(self, FillUtil.FILLTYPE_FORAGE, info.fillTypeName, nil);					
			info.fillTypeName = fillTypeNameString;
			info.pricePerLiter = pricePerLiter;
			table.insert(outputFillTypes[container], info);
			table.remove(info);
			container = 1;
			for a=1, table.getn(objectTable.MixTypLvl) do		
				info={};
				info.capacity = objectTable.TipTriggers[a].capacity;	
				info.fillLevel = objectTable.MixTypLvl[a];
				if info.fillLevel <= 0.1 then inputEmpty = true;end;
				if not outputFull then
					if not inputEmpty then
						capacity = capacity+info.capacity;
						fillLevel = fillLevel+info.fillLevel;
					end;					
				end;
				info.container = container;
				info.fillTypeName = "";
				info.lengthFillTypes = 1;					
				inputFillTypes[container] = {};
				local pricePerLiter, fillTypeNameString = moSetGetInputOutputOther:getFillTypeStringName(self, objectTable.MixTypName[a].index, info.fillTypeName, nil);					
				info.fillTypeName = fillTypeNameString;
				info.pricePerLiter = pricePerLiter;
				table.insert(inputFillTypes[container], info);
				container = container+1;
			end;
			table.remove(info);			
		elseif name == "seedmaster2k15" or name == "beetmaster100k" or name == "kompostier_anlage" or otherType == "fermentingsilo" then --SeedMaster2k15,BeetMaster100K,Kompostier_Anlage
			setProduktivity = true;
			local info={};
			info.capacity = objectTable.TipTrigger.capacity;	
			info.fillLevel = objectTable.SilageLvl;
			ratio = Utils.getNoNil(info.fillLevel/info.capacity*100, 0);
			if tonumber(ratio) >= 100 then outputFull = true;end;
			--if tonumber(productivity) >= tonumber(ratio) then
			--	productivity = tonumber(ratio);	
			--end;
			info.container = container;
			info.fillTypeName = "";
			info.lengthFillTypes = 1;					
			outputFillTypes[container] = {};
			local pricePerLiter, fillTypeNameString = moSetGetInputOutputOther:getFillTypeStringName(self, objectTable.SilageTrigger.fillType, info.fillTypeName, objectTable.L_Silage);					
			info.fillTypeName = fillTypeNameString;
			info.pricePerLiter = pricePerLiter;
			table.insert(outputFillTypes[container], info);			
			table.remove(info);
			container = 1;
			info={};
			info.capacity = objectTable.TipTrigger.capacity;
			info.fillLevel = objectTable.FillLvl;
			ratio = Utils.getNoNil(info.fillLevel/info.capacity*100, 0);
			if info.fillLevel <= 0.1 then inputEmpty = true;end;
			if not outputFull then
				if not inputEmpty then
					capacity = capacity+info.capacity;
					fillLevel = fillLevel+info.fillLevel;
				end;
			end;			
			info.container = container;					
			info.fillTypeName = "";
			info.lengthFillTypes = 1;					
			inputFillTypes[container] = {};
			local fruitNames = "";
			local b = 1;		
			for acceptedFillTypes, v in pairs(objectTable.TipTrigger.acceptedFillTypes) do 			
				if v then
					local pricePerLiter, fillTypeNameString = moSetGetInputOutputOther:getFillTypeStringName(self, acceptedFillTypes, info.fillTypeName, nil);
					if not string.find(info.fillTypeName, fillTypeNameString) then info.lengthFillTypes = info.lengthFillTypes+1;end;
					info.fillTypeName = fillTypeNameString;					
				end;
				b = b+1			
			end;			
			table.insert(inputFillTypes[container], info);
			table.remove(info);			
		elseif otherType == "mixfeeder" and objectTable.mixFeeder ~= nil and objectTable.bunkerMixFeeder ~= nil then --MixFeeder
			local info={};			
			--objectTable.mixFeeder.type
			--objectTable.mixFeeder.noFatteningFeeder
			info.fillLevel = 0;
			info.capacity = -2;									
			info.pricePerLiter = 0;
			info.fillTypeName = tostring(moLanguageXml:getTxt("animals", nil, "Animals")).. ": ";
			if objectTable.type ~= nil then
				local animalType = objectTable.type;
				info.fillTypeName = info.fillTypeName.. tostring(moLanguageXml:getTxt(string.lower(animalType), nil, tostring(animalType)));
			end;
			if objectTable.noFatteningFeeder ~= nil then
				if not objectTable.noFatteningFeeder then
					info.fillTypeName = info.fillTypeName.. tostring(moLanguageXml:getTxt("a_mast", nil, "(mast)"));
				else
					info.fillTypeName = info.fillTypeName.. tostring(moLanguageXml:getTxt("a_breeding", nil, "(breeding)"));
				end;
			end;			
			info.lengthFillTypes = 1;
			outputFillTypes[container] = {};			
			local nextFillType = true;
			--if objectTable.feederBuyed ~= nil then
			--	if objectTable.feederBuyed then nextFillType = false;end;
			--end;
			if not nextFillType then
				info.extraText = tostring(moLanguageXml:getTxt("off", nil, "Off"));
				info.setColor = moGuiMiniPdaSlots.warningColor4;
				table.insert(outputFillTypes[container], info);
				container = container+1;
				table.remove(info);
			else
				setProduktivity = true;
				table.insert(outputFillTypes[container], info);
				info.setColor = moGuiMiniPdaSlots.warningColor1;
				container = container+1;
				table.remove(info);
				info={};			
				info.capacity = Utils.getNoNil(objectTable.mixFeeder.capacity, 0);	
				info.fillLevel = Utils.getNoNil(objectTable.mixFeeder.fillLevel, 0);
				ratio = Utils.getNoNil(info.fillLevel/info.capacity*100, 0);
				if tonumber(ratio) >= 100 then outputFull = true;end;
				--if tonumber(productivity) >= tonumber(ratio) then
				--	productivity = tonumber(ratio);	
				--end;
				info.container = container;
				info.fillTypeName = "";
				info.lengthFillTypes = 1;					
				outputFillTypes[container] = {};
				local pricePerLiter, fillTypeNameString = moSetGetInputOutputOther:getFillTypeStringName(self, FillUtil.FILLTYPE_FORAGE, info.fillTypeName, nil);					
				info.fillTypeName = fillTypeNameString;
				info.pricePerLiter = pricePerLiter;
				table.insert(outputFillTypes[container], info);
				table.remove(info);
				container = 1;				
				for k, v in pairs(objectTable.bunkerMixFeeder) do							
					info={};
					info.capacity = Utils.getNoNil(v.fillLevel, 0);
					info.fillLevel = Utils.getNoNil(v.fillLevel,0 );
					if info.fillLevel <= 0.1 then inputEmpty = true;end;
					if v.capacityUse and not outputFull then
						if not inputEmpty then
							info.capacity = Utils.getNoNil(v.capacity, 0)
							capacity = capacity+info.capacity;
							fillLevel = fillLevel+info.fillLevel;
						end;
					end;
					info.container = container;					
					info.fillTypeName = tostring(moLanguageXml:getTxt("b_".. k, nil, tostring(g_i18n:getText("MixFeeder_"..k)))) --"";
					info.lengthFillTypes = 1;
					--local key = "FILLTYPE_"..string.upper(k);
					--local pricePerLiter, fillTypeNameString = moSetGetInputOutputOther:getFillTypeStringName(self, FillUtil[key], info.fillTypeName, nil);
					inputFillTypes[container] = {};
					--info.fillTypeName = fillTypeNameString;
					info.pricePerLiter = 0;
					table.insert(inputFillTypes[container], info);
					container = container+1;
					table.remove(info);
				end;
			end;			
		end;
	elseif objectTable ~= nil and xmlModString ~= nil and string.find(xmlModString, "heaptiptrigger") then		
		local foundHeapsFillLevel = false;		
		local cancel = false;
		local acceptedFillTypes = {};
		if objectTable.acceptedFillTypes ~= nil then
			acceptedFillTypes = objectTable.acceptedFillTypes
		end;
		local info = {};
		info.fillTypeName = "";						
		info.pricePerLiter = 0;
		info.capacity = 0;
		info.fillLevel = 0;
		info.lengthFillTypes = 1;
		info.fillTypeContainerName = nil;
		for fillType,isAccepted in pairs(acceptedFillTypes) do				
			if cancel then break;end;
			if(isAccepted)then										
				info.fillLevel = objectTable:getFillLevel(fillType);						
				if info.fillLevel > 0.1 then cancel = true;foundHeapsFillLevel = true;info.fillTypeName = "";info.fillTypeContainerName = nil;end;
				local pricePerLiter, fillTypeNameString = moSetGetInputOutputOther:getFillTypeStringName(self, fillType, info.fillTypeName, nil);
				if info.fillTypeName ~= fillTypeNameString then info.lengthFillTypes = info.lengthFillTypes+1;info.fillTypeName = fillTypeNameString;end;
				info.fillTypeName = fillTypeNameString;
				info.pricePerLiter = pricePerLiter;				
			end;
		end;
		if not foundHeapsFillLevel then
			info.fillTypeContainerName = tostring(moLanguageXml:getTxt("empty", nil, "--Empty--"));				
			inputFillTypes[container] = {};
			table.insert(inputFillTypes[container], info);			
		else
			info.lengthFillTypes = 1;
			outputFillTypes[container] = {};
			table.insert(outputFillTypes[container], info);
		end;		
	end;
	if setProduktivity then		
		productivity = Utils.getNoNil(fillLevel/capacity*100, 0);
		if not outputFull and not inputEmpty then
			if tonumber(productivity) <= 90 and tonumber(productivity) >= 75 then
				productivityColor = moGuiMiniPdaSlots.warningColor1;
			elseif tonumber(productivity) < 75 and tonumber(productivity) >= 50 then
				productivityColor = moGuiMiniPdaSlots.warningColor2;
			elseif tonumber(productivity) < 50 and tonumber(productivity) >= 25 then
				productivityColor = moGuiMiniPdaSlots.warningColor3;
			elseif tonumber(productivity) < 25 then
				productivityColor = moGuiMiniPdaSlots.warningColor4;
			end;
		else
			if inputEmpty then 
				productivity = 0;
				productivityColor = moGuiMiniPdaSlots.warningColor4;
			else
				productivity = 50;
				productivityColor = moGuiMiniPdaSlots.warningColor2;
			end;
		end;
		outputFillTypes[1][1].productivity = productivity;
		outputFillTypes[1][1].productivityColor = productivityColor;	
	end;
	return inputFillTypes, outputFillTypes	
end;

function moSetGetInputOutputOther:getProzentColor(fillProzent)	
	local ratio = tonumber(fillProzent);
	local color = moGuiMiniPdaSlots.warningColor0;
	if tonumber(ratio) >= 90 then		
		return moGuiMiniPdaSlots.warningColor4;
	elseif tonumber(ratio) < 90 and tonumber(ratio) >= 75 then		
		return moGuiMiniPdaSlots.warningColor3;
	elseif tonumber(ratio) < 75 and tonumber(ratio) >= 50 then
		return moGuiMiniPdaSlots.warningColor2;
	elseif tonumber(ratio) < 50 and tonumber(ratio) >= 15 then		
		return moGuiMiniPdaSlots.warningColor1;
	elseif tonumber(ratio) < 15 then		
		return moGuiMiniPdaSlots.warningColor0;
	end;
	return color;
end;

function moSetGetInputOutputOther:getProductivityColor(self, productivity)
	local ratio = productivity;
	local color = moGuiMiniPdaSlots.warningColor0;
	if tonumber(ratio) <= 90 and tonumber(ratio) >= 75 then
		color = moGuiMiniPdaSlots.warningColor1; --moGuiExtras.colors['greenDisabled'];
	elseif tonumber(ratio) < 75 and tonumber(ratio) >= 50 then
		color = moGuiMiniPdaSlots.warningColor2; --moGuiExtras.colors['yellow'];
	elseif tonumber(ratio) < 50 and tonumber(ratio) >= 25 then
		color = moGuiMiniPdaSlots.warningColor3; --moGuiExtras.colors['red'];
	elseif tonumber(ratio) < 25 then
		color = moGuiMiniPdaSlots.warningColor4; --moGuiExtras.colors['redDisabled'];
	end;
	return color;
end;

function moSetGetInputOutputOther:getFruitPrice(self, fillType)	
	local bestPrice = 0;	
	local desc = FillUtil.fillTypeIndexToDesc[fillType];	
	if desc ~= nil and moFillTypes[desc.index] ~= nil then		
		if moFillTypes[desc.index].bestPrice ~= 0 then 
			bestPrice = string.format("%.1f", moFillTypes[desc.index].bestPrice);
		else
			bestPrice = string.format("%.1f", Utils.getNoNil(g_currentMission.economyManager:getPricePerLiter(desc.index, 0)));
		end;		
	end;
	return bestPrice;
end;

function moSetGetInputOutputOther:getFillTypeName(fillType)
	local desc = FillUtil.fillTypeIndexToDesc[fillType];
	if desc ~= nil and moFillTypes[desc.index] ~= nil and moFillTypes[desc.index].fruitName ~= nil then
		return moFillTypes[desc.index].fruitName;
	elseif desc ~= nil then
		return desc.name;
	end;
	return "Unknow";
end;

function moSetGetInputOutputOther:getFillTypeStringName(self, fillType, fillTypeNameString, fillTypeName)
	local pricePerLiter = 0;
	local stringName = fillTypeNameString;
	local desc = FillUtil.fillTypeIndexToDesc[fillType];	
	if desc ~= nil and moFillTypes[desc.index] ~= nil and moFillTypes[desc.index].fruitName ~= nil then								
		local bestPriceTemp = 1;		
		if moFillTypes[desc.index].bestPrice ~= 0 then bestPriceTemp = moFillTypes[desc.index].bestPrice;end;
		--pricePerLiter = moFillTypes[desc.index].pricePerLiter*bestPriceTemp*moGeneralSettings.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;		
		if not string.find(stringName, moFillTypes[desc.index].fruitName) then
			if string.len(stringName) > 0 then
				stringName = stringName.. ",".. moFillTypes[desc.index].fruitName;									
			else
				stringName = moFillTypes[desc.index].fruitName;
			end;								
		end;
	elseif fillTypeName ~= nil then		
		if not string.find(stringName, fillTypeName) then
			if string.len(stringName) > 0 then
				stringName = stringName.. ",".. fillTypeName;									
			else
				stringName = fillTypeName;
			end;								
		end;
	else
		if not string.find(stringName, tostring(moLanguageXml:getTxt("unknow"))) then
			if string.len(stringName) > 0 then
				stringName = stringName.. ",".. tostring(moLanguageXml:getTxt("unknow"));									
			else
				stringName = tostring(moLanguageXml:getTxt("unknow"));
			end;								
		end;	
	end;	
	return pricePerLiter, stringName
end;